#pragma once

#include <Game/Core.hpp>
#include <bt/behavior_node.hpp>

namespace bt {

template <typename Context, typename ItemID>
  requires std::same_as<std::int32_t, ItemID> ||
           std::same_as<std::string, ItemID> ||
           std::same_as<std::regex, ItemID> ||
           std::same_as<std::vector<std::int32_t>, ItemID> ||
           std::same_as<std::initializer_list<std::int32_t>, ItemID> ||
           std::same_as<std::vector<std::string>, ItemID> ||
           std::same_as<std::initializer_list<std::string>, ItemID>
class inventory_contains_node : public behavior_node<Context> {
public:
  ItemID item_id;

  inventory_contains_node(ItemID item_id) : item_id(item_id) {}

  node_task tick(Context &ctx) noexcept override {
    if (!Inventory::Contains(item_id))
      co_return task_result::failure;

    co_return task_result::success;
  }
};

} // namespace bt